#include "d_Move.h"
#include "d_Board.h"
//-----------------------------------------------------------------------------------
/* +
 *     
 *
 *  ChessTerminator75
 *   17.1.2007
          
*/
//---------------------------------------------------------------------------
//	===================================================================
// 0-  1- 2- 3- 4- 5- 6-
// 0-   1-    , 2-, 3- 
// 4-, 5-  , 6- 
//x_s y_s source y x     
//x_r y_r result y x     
void Realization_Moves(int x_s,int y_s,int x_r,int y_r,int chess_board_s[],int chess_board_r[],int legal_move[],char promotion, int * f){

//0     -------------------------------------------------
	for (int x=0 ;x<138;x++){
	  chess_board_r[x]=chess_board_s[x];
	}//for (int xv=0 ;xv<138;xv++){

//  
   Marker_Taking_On_Passage(x_s,y_s,x_r,y_r,chess_board_r);
//  
   Marker_Stop_Castling(x_s,y_s,x_r,y_r,chess_board_r);

//1    -----------------------------------------------------------------------

	if (xy_board_out(1,x_r,y_r,legal_move)==1){
//     
	xy_board_in(1,x_r,y_r,(xy_board_out(1,x_s,y_s,chess_board_s)),chess_board_r);
//       
    xy_board_in(2,x_r,y_r,(xy_board_out(2,x_s,y_s,chess_board_s)),chess_board_r);
//     
    xy_board_in(1,x_s,y_s,0,chess_board_r);
    xy_board_in(2,x_s,y_s,0,chess_board_r);
//   
    int m = 1 - xy_board_out(0,-1,-1,chess_board_r);
    xy_board_in(0,-1,-1,m,chess_board_r);
	}//if (xy_board_out(1,x_r,y_r,legal_move)==1){

//2--------------------------------------------------------------------------------
  if (xy_board_out(1,x_r,y_r,legal_move)==2){
//     
	xy_board_in(1,x_r,y_r,(xy_board_out(1,x_s,y_s,chess_board_s)),chess_board_r);
//       
    xy_board_in(2,x_r,y_r,(xy_board_out(2,x_s,y_s,chess_board_s)),chess_board_r);
//     
    xy_board_in(1,x_s,y_s,0,chess_board_r);
    xy_board_in(2,x_s,y_s,0,chess_board_r);

 //       
    if (y_r==1){
	  if (x_r==7){
		         //   
		        	  xy_board_in(1,6,1,2,chess_board_r);
		         //  
		        	  xy_board_in(2,6,1,0,chess_board_r);
		         //    
		              xy_board_in(1,8,1,0,chess_board_r);
                      xy_board_in(2,8,1,0,chess_board_r);
		          }// if (x_r==7)
	  if (x_r==3){
                 //   
		        	  xy_board_in(1,4,1,2,chess_board_r);
		         //  
		        	  xy_board_in(2,4,1,0,chess_board_r);
		         //    
		              xy_board_in(1,1,1,0,chess_board_r);
                      xy_board_in(2,1,1,0,chess_board_r);

		          }// if (x_r==3)
		        }//if (y_r==1)

//     
		      if (y_r==8){
		        if (x_r==7){
                 //   
		        	  xy_board_in(1,6,8,2,chess_board_r);
		         //  
		        	  xy_board_in(2,6,8,1,chess_board_r);
		         //    
		              xy_board_in(1,8,8,0,chess_board_r);
                      xy_board_in(2,8,8,0,chess_board_r);

		        }// if (x_r==7)
		        if (x_r==3){
                 //   
		        	  xy_board_in(1,4,8,2,chess_board_r);
		         //  
		        	  xy_board_in(2,4,8,1,chess_board_r);
		         //    
		              xy_board_in(1,1,8,0,chess_board_r);
                      xy_board_in(2,1,8,0,chess_board_r);

		        }// if (x_r==3)
		      }//if (y_r==8)
    //   
    int m = 1 - xy_board_out(0,-1,-1,chess_board_r);
    xy_board_in(0,-1,-1,m,chess_board_r);
	}//if (xy_board_out(1,x_r,y_r,legal_move)==2){

//3  -----------------------------------------------------------------------
	if (xy_board_out(1,x_r,y_r,legal_move) == 3){
    *f =1; //      
//     
	int pr=char_to_int_board(promotion);
	xy_board_in(1,x_r,y_r,pr,chess_board_r);
//       
    xy_board_in(2,x_r,y_r,(xy_board_out(2,x_s,y_s,chess_board_s)),chess_board_r);
//     
      xy_board_in(1,x_s,y_s,0,chess_board_r);
      xy_board_in(2,x_s,y_s,0,chess_board_r);
    //   
    int m = 1 - xy_board_out(0,-1,-1,chess_board_r);
    xy_board_in(0,-1,-1,m,chess_board_r);
	}//if (xy_board_out(1,x_r,y_r,legal_move) == 3){

//4 ----------------------------------------------------------------------------------
   if (xy_board_out(1,x_r,y_r,legal_move)==4){
//     
	xy_board_in(1,x_r,y_r,(xy_board_out(1,x_s,y_s,chess_board_s)),chess_board_r);
//       
    xy_board_in(2,x_r,y_r,(xy_board_out(2,x_s,y_s,chess_board_s)),chess_board_r);
//     
    xy_board_in(1,x_s,y_s,0,chess_board_r);
    xy_board_in(2,x_s,y_s,0,chess_board_r);
    //   
    int m = 1 - xy_board_out(0,-1,-1,chess_board_r);
    xy_board_in(0,-1,-1,m,chess_board_r);
	}//if (xy_board_out(1,x_r,y_r,legal_move)==4){



//5   -----------------------------------------------------------------------
	if (xy_board_out(1,x_r,y_r,legal_move)  == 5){		       
	//     
	xy_board_in(1,x_r,y_r,(xy_board_out(1,x_s,y_s,chess_board_s)),chess_board_r);
//       
    xy_board_in(2,x_r,y_r,(xy_board_out(2,x_s,y_s,chess_board_s)),chess_board_r);

//          		
      xy_board_in(1,x_s,y_s,0,chess_board_r);
      xy_board_in(2,x_s,y_s,0,chess_board_r);
      xy_board_in(1,x_r,y_r-1,0,chess_board_r);
      xy_board_in(2,x_r,y_r-1,0,chess_board_r);
      xy_board_in(1,x_r,y_r+1,0,chess_board_r);
      xy_board_in(2,x_r,y_r+1,0,chess_board_r);
//   
    int m = 1 - xy_board_out(0,-1,-1,chess_board_r);
    xy_board_in(0,-1,-1,m,chess_board_r);
	}//if (xy_board_out(1,x_r,y_r,legal_move)  == 5){



//6   :))-------------------------------------------------------------------------------
  if (xy_board_out(1,x_r,y_r,legal_move)==6){
//     
	xy_board_in(1,x_r,y_r,(xy_board_out(1,x_s,y_s,chess_board_s)),chess_board_r);
//       
    xy_board_in(2,x_r,y_r,(xy_board_out(2,x_s,y_s,chess_board_s)),chess_board_r);
//     
    xy_board_in(1,x_s,y_s,0,chess_board_r);
    xy_board_in(2,x_s,y_s,0,chess_board_r);
//   
    int m = 1 - xy_board_out(0,-1,-1,chess_board_r);
    xy_board_in(0,-1,-1,m,chess_board_r);
	}//if (xy_board_out(1,x_r,y_r,legal_move)==6){

}//Realization_Moves(int x_s,int y_s,int x_r,int y_r,int chess_board_s[],int chess_board_r[],int legal_move[]){
//	*******************************************************************

//	===================================================================
//             
void Marker_Taking_On_Passage(int x_s,int y_s,int x_r,int y_r,int chess_board[]){
//	              
//	        
//	  1 ,  2  ,  3  
	
//        		
	  xy_board_in(3,1,-1,0,chess_board);
	    
	  if(xy_board_out(1,x_s,y_s,chess_board)==1){
	    if(xy_board_out(2,x_s,y_s,chess_board)==1){
	      if ((y_s==7)&(y_r==5)){
             xy_board_in(3,1,-1,1,chess_board);
			 xy_board_in(3,2,-1,x_s,chess_board); //x
			 xy_board_in(3,3,-1,6,chess_board);
	        }//if ((y_s==7)&(y_r==5)){
	    }else{
	     if ((y_s==2)&(y_r==4)){
	     	 xy_board_in(3,1,-1,1,chess_board);
			 xy_board_in(3,2,-1,x_s,chess_board); //x
			 xy_board_in(3,3,-1,3,chess_board);
		    }//if ((y_s==2)&(y_r==4)){
	     }//if(xy_board_out(2,x_s,y_s,chess_board)==1){
	  }//if(xy_board_out(1,x_s,y_s,chess_board)==1)
}//Marker_Taking_On_Passage(int x_s,int y_s,int x_r,int y_r,int chess_board[]){

//	*******************************************************************

//	===================================================================
//        
void Marker_Stop_Castling(int x_s,int y_s,int x_r,int y_r,int chess_board[]){
//	  1 , 0  
//	  1,   2,    3,    4
//	,   5,    6

//              
	
	 //------------------------------------------------------------
	 //        
	     if(xy_board_out(1,x_s,y_s,chess_board)==2){
	       if(xy_board_out(2,x_s,y_s,chess_board)==1){
	       //--------------
	       //  
	        if (( y_s ==8)&( x_s ==1)) xy_board_in(4,3,-1,1,chess_board);
	        if (( y_s ==8)&( x_s ==8)) xy_board_in(4,4,-1,1,chess_board);
	       //--------------
	       }else{
	       //--------------
	       //  
	        if (( y_s ==1)&( x_s ==1)) xy_board_in(4,5,-1,1,chess_board);
	        if (( y_s ==1)&( x_s ==8)) xy_board_in(4,6,-1,1,chess_board);

	       //--------------
	       }// if (Chess_Figure_Name[Depth][y_s][x_s]=='r')
	    }// if (Chess_Figure_Color[Depth][y_s][x_s]==1)

	  //------------------------------------------------------------
	 //        
	    if(xy_board_out(1,x_s,y_s,chess_board)==6){
	      if(xy_board_out(2,x_s,y_s,chess_board)==1){
	        //   
	      	xy_board_in(4,1,-1,1,chess_board);
	      }else{
	        //   
	      	xy_board_in(4,2,-1,1,chess_board);
	      }//if(xy_board_out(2,x_s,y_s,chess_board)==1){
	    }//if(xy_board_out(1,x_s,y_s,chess_board)==6){

}//Marker_Stop_Castling(int x_s,int y_s,int x_r,int y_r,int chess_board[]){

//	*******************************************************************